import time

class ProcessingTimeSaver:

	def __init__(self, 
				filename, 
				get_callback_time_func,
				get_image_processing_time_func,
				sample_time_seconds):

		callback_processing_time = []
		image_processing_time    = []

		print "Starting to sample for", sample_time_seconds, "seconds"
		t_end = time.time() + sample_time_seconds
		while time.time() < t_end:
			t1 = get_callback_time_func()
			t2 = get_image_processing_time_func()
			if t1 != None:
				callback_processing_time.append(t1)   		
			if t2 != None:
				image_processing_time.append(t2)

			#sleep 10 milliseconds so that the receiving thread is not overflowd
			time.sleep(10/1000)

		
		print ("Finished sampling. Got ", len(callback_processing_time), "callback processing time samples", 
				"and", len(image_processing_time), "image processing time samples")

		with open("../" + filename, 'w') as fp:
			fp.write("Callback processing time:\n")
			for elem in callback_processing_time:
				fp.write(str(elem) + '\n')
			fp.write("\nImage processing time:\n")
			for elem in image_processing_time:
				fp.write(str(elem) + '\n')
				
