#include "scan_config.h"

#include <string.h>
#include "app_error.h"
#include "request_response.h"

scan_config_t m_config;


ret_code_t scan_config_send_all(void)
{
	ret_code_t ret_code;

	m_config.scan_mode = SCAN_MODE_0;

	m_config.image_info.frame_height = 192;
	m_config.image_info.num_scan_lines_per_image = 640;
	m_config.scanner_ready_pin = gpio36; // gpio57
	m_config.fps = 400;
	m_config.cycle_time_diff_threshold_ms = 0.5;

	m_config.img_processing_config.threads_per_block = 512;
	m_config.img_processing_config.frames_per_message = 32;
	m_config.img_processing_config.num_streams = 4;
	m_config.img_processing_config.scatter_distance = 10;
	m_config.img_processing_config.threshold_value = 3000;
	m_config.img_processing_config.pixel_power = 3;

	message_t request, response;
	request.type = MSG_TYPE_CONFIG_SCAN;
	request.request.p_payload = (void*)&m_config;
	request.request.payload_len = sizeof(m_config);

	LOG_DEBUG("Sending output config request\n");
	ret_code = issue_request(&request, &response);
	RETURN_ON_ERROR(ret_code);
	RETURN_ON_ERROR(response.response.ret_code);

	return RET_SUCCESS;
}